Unit ID22R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, II21R2_p;

function ID22R(var T :Array of Real; var A :Array of Real; N :Integer;
                K :Integer; X :Real; ID :Integer;
                var R :Array of Real): Real;

implementation

function ID22R(var T :Array of Real; var A :Array of Real; N :Integer;
                K :Integer; X :Real; ID :Integer;
                var R :Array of Real): Real;
var
IDERIV,KMIDER,KM1,I,MFLAG,IMK,IMKPJ,J,KMJ,JJ,IHI,IHMKMJ,IP1,IPJ,IP1MJ,
   IDERP1,ILO :Integer;
FKMJ :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
{ Result -    ID22R  FORTRANe }
Result := ZERO;
IDERIV := ID;
KMIDER := K-IDERIV;
if ( KMIDER <= 0 ) 
 then goto _9;
KM1 := K-1;
II21R2(T,N+1,X,I,MFLAG);
if ( X < T[K-1] ) 
 then goto _9;
if ( MFLAG = 0 ) 
 then goto _2;
if ( X > T[I-1] ) 
 then goto _9;
_1:
if ( I = K ) 
 then goto _9;
I := I-1;
if ( X = T[I-1] ) 
 then goto _1;
_2:
IMK := I-K;
for J:=1 to K do
 begin
  IMKPJ := IMK+J;
_3:
  R[0+(J-1)*3] := A[IMKPJ-1];
 end;
if ( IDERIV = 0 ) 
 then goto _5;
for J:=1 to IDERIV do
 begin
  KMJ := K-J;
  FKMJ := (KMJ);
  for JJ:=1 to KMJ do
   begin
    IHI := I+JJ;
    IHMKMJ := IHI-KMJ;
_4:
    R[0+(JJ-1)*3] := (R[0+(JJ+1-1)*3]-R[0+(JJ-1)*3])/(T[IHI-1]-T[IHMKMJ-1])*FKMJ;
   end;
 end;
_5:
if ( IDERIV = KM1 ) 
 then goto _8;
IP1 := I+1;
for J:=1 to KMIDER do
 begin
  IPJ := I+J;
  R[1+(J-1)*3] := T[IPJ-1]-X;
  IP1MJ := IP1-J;
_6:
  R[2+(J-1)*3] := X-T[IP1MJ-1];
 end;
IDERP1 := IDERIV+1;
for J:=IDERP1 to KM1 do
 begin
  KMJ := K-J;
  ILO := KMJ;
  for JJ:=1 to KMJ do
   begin
    R[0+(JJ-1)*3] := (R[0+(JJ+1-1)*3]*R[2+(ILO-1)*3]+R[0+(JJ-1)*3]*R[1+(JJ-1)*3])/(R[2+(ILO-1)*3]
    +R[1+(JJ-1)*3]);
_7:
    ILO := ILO-1;
   end;
 end;
_8:
Result := R[0];
_9:
exit;
end;

end.
